package cn.com.qmth.examcloud.core.questions.starter;

import cn.com.qmth.examcloud.core.questions.service.ExtractConfigProviderService;
import cn.com.qmth.examcloud.core.questions.service.cache.BasePaperCache;
import cn.com.qmth.examcloud.core.questions.service.cache.Constants;
import cn.com.qmth.examcloud.core.questions.service.cache.QuestionCache;
import cn.com.qmth.examcloud.question.commons.core.paper.DefaultPaper;
import cn.com.qmth.examcloud.support.cache.CacheHelper;
import cn.com.qmth.examcloud.support.cache.bean.BasePaperCacheBean;
import cn.com.qmth.examcloud.support.cache.bean.QuestionCacheBean;
import cn.com.qmth.examcloud.web.redis.RedisClient;
import cn.com.qmth.examcloud.web.support.Naked;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Set;

@Controller
@RequestMapping("${api_cqb}/")
public class DemoController {
    private static final Logger log = LoggerFactory.getLogger(DemoController.class);
    @Autowired
    private RedisTemplate<String, Object> redisTemplate;
    @Autowired
    private RedisClient redisClient;
    @Autowired
    private BasePaperCache basePaperCache;
    @Autowired
    private QuestionCache questionCache;
    @Autowired
    private ExtractConfigProviderService extractConfigProviderService;

    @Naked
    @ResponseBody
    @RequestMapping(value = "/demo", method = RequestMethod.GET)
    public String demo(HttpServletRequest request, HttpServletResponse response) throws Exception {
        Long examId = 319L;
        String courseCode = "course-fds";
        String groupCode = "X";
        String paperId = "f4e8b8a3-9f2f-4455-a3c1-62942f1ed171";
        String questionId = "5d5e109aef8fce4eeda1ee12";

        //ExtractConfigPaper extractConfigPaper = extractConfigProviderService.getDefaultPaper(examId, courseCode, groupCode);
        //log.info("调卷抽取的试卷结构：" + extractConfigPaper.getDefaultPaper().getName());
        String cacheKey = Constants.CACHE_KEY_PAPER_FOR_EXTRACT_CONFIG + String.format("%s_%s_%s_%s", examId, courseCode, groupCode, paperId);
        DefaultPaper defaultPaper = redisClient.get(cacheKey, DefaultPaper.class, Constants.DEFAULT_TIME_OUT);
        log.info("--->缓存的试卷结构: " + defaultPaper.getName());

        BasePaperCacheBean basePaperCacheBean = CacheHelper.getBasePaper(paperId);
        log.info("--->缓存的试卷结构: " + basePaperCacheBean.getDefaultPaper().getName());
        //basePaperCache.remove(paperId);

        QuestionCacheBean questionCacheBean = CacheHelper.getQuestion(examId, courseCode, groupCode, questionId);
        log.info("--->缓存的试题: " + questionCacheBean.getDefaultQuestion().getId());
        //questionCache.remove(examId, courseCode, groupCode, questionId);


        //获取缓存KEYS
        final String patternKey = Constants.CACHE_KEY_PAPER + "*" + paperId;
        //final String patternKey = Constants.CACHE_KEY_QUESTION + "*" + questionId;
        Set<String> keys = redisTemplate.keys(patternKey);
        log.info(StringUtils.join(keys, ","));

        return "ok";
    }

}